//
// Shopper.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Shopper: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var userId: Int?
    public var memberId: Int?
    public var username: String?
    public var price: Double?
    public var priceVerified: Bool?
    public var locationVerified: Bool?
    public var tutorialStep: Int?
    public var searchRadius: Int?
    public var searchCity: String?
    public var filterLocation: Bool?
    public var searchHistory: String?
    public var imageFilter: String?
    public var createdAt: Date?
    public var updatedAt: Date?
    public var user: User?
    public var member: Member?

    public init(id: Int? = nil, userId: Int? = nil, memberId: Int? = nil, username: String? = nil, price: Double? = nil, priceVerified: Bool? = nil, locationVerified: Bool? = nil, tutorialStep: Int? = nil, searchRadius: Int? = nil, searchCity: String? = nil, filterLocation: Bool? = nil, searchHistory: String? = nil, imageFilter: String? = nil, createdAt: Date? = nil, updatedAt: Date? = nil, user: User? = nil, member: Member? = nil) {
        self.id = id
        self.userId = userId
        self.memberId = memberId
        self.username = username
        self.price = price
        self.priceVerified = priceVerified
        self.locationVerified = locationVerified
        self.tutorialStep = tutorialStep
        self.searchRadius = searchRadius
        self.searchCity = searchCity
        self.filterLocation = filterLocation
        self.searchHistory = searchHistory
        self.imageFilter = imageFilter
        self.createdAt = createdAt
        self.updatedAt = updatedAt
        self.user = user
        self.member = member
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case userId
        case memberId
        case username
        case price
        case priceVerified
        case locationVerified
        case tutorialStep
        case searchRadius
        case searchCity
        case filterLocation
        case searchHistory
        case imageFilter
        case createdAt
        case updatedAt
        case user = "User"
        case member = "Member"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(userId, forKey: .userId)
        try container.encodeIfPresent(memberId, forKey: .memberId)
        try container.encodeIfPresent(username, forKey: .username)
        try container.encodeIfPresent(price, forKey: .price)
        try container.encodeIfPresent(priceVerified, forKey: .priceVerified)
        try container.encodeIfPresent(locationVerified, forKey: .locationVerified)
        try container.encodeIfPresent(tutorialStep, forKey: .tutorialStep)
        try container.encodeIfPresent(searchRadius, forKey: .searchRadius)
        try container.encodeIfPresent(searchCity, forKey: .searchCity)
        try container.encodeIfPresent(filterLocation, forKey: .filterLocation)
        try container.encodeIfPresent(searchHistory, forKey: .searchHistory)
        try container.encodeIfPresent(imageFilter, forKey: .imageFilter)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(user, forKey: .user)
        try container.encodeIfPresent(member, forKey: .member)
    }
}

